/// <reference types="react" />
import * as React from 'react';
import { IResizableScss } from './scss';
export interface IWithFitToParentState {
    width: number;
    height: number;
}
export interface IParentSizeFitParamaters {
    toWidth?: boolean;
    toHeight?: boolean;
    /**
     * If fitToParentWidth is true, defines the offset of width that will be substracted
     * from parent HTML client width and set as the final width
     */
    offsetWidth?: number;
    /**
     * If fitToParentWidth is true, defines the offset of height that will be substracted
     * from parent HTML client height and set as the final height
     */
    offsetHeight?: number;
}
export interface IWithFitToParentProps {
    fitToParent?: IParentSizeFitParamaters;
}
export interface IResizeableComponentProps {
    scss: IResizableScss;
    refCallback?: (ref: any) => void;
}
export declare function withFitToParent<P extends IResizeableComponentProps>(WrappedComponent: React.ComponentClass<IResizeableComponentProps> | React.StatelessComponent<IResizeableComponentProps>): {
    new (props: P & IWithFitToParentProps): {
        parentElement: any;
        resizeCallback: () => void;
        componentWillMount(): void;
        componentDidMount(): void;
        componentWillUnmount(): void;
        render(): JSX.Element;
        setState<K extends "width" | "height">(state: IWithFitToParentState | ((prevState: Readonly<IWithFitToParentState>, props: P & IWithFitToParentProps) => IWithFitToParentState | Pick<IWithFitToParentState, K>) | Pick<IWithFitToParentState, K>, callback?: () => any): void;
        forceUpdate(callBack?: () => any): void;
        props: Readonly<{
            children?: React.ReactNode;
        }> & Readonly<P & IWithFitToParentProps>;
        state: Readonly<IWithFitToParentState>;
        context: any;
        refs: {
            [key: string]: React.ReactInstance;
        };
        componentWillReceiveProps?(nextProps: Readonly<P & IWithFitToParentProps>, nextContext: any): void;
        shouldComponentUpdate?(nextProps: Readonly<P & IWithFitToParentProps>, nextState: Readonly<IWithFitToParentState>, nextContext: any): boolean;
        componentWillUpdate?(nextProps: Readonly<P & IWithFitToParentProps>, nextState: Readonly<IWithFitToParentState>, nextContext: any): void;
        componentDidUpdate?(prevProps: Readonly<P & IWithFitToParentProps>, prevState: Readonly<IWithFitToParentState>, prevContext: any): void;
    };
};
