"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
}
Object.defineProperty(exports, "__esModule", { value: true });
var _ = __importStar(require("lodash"));
var React = __importStar(require("react"));
function withFitToParent(WrappedComponent) {
    return /** @class */ (function (_super) {
        __extends(class_1, _super);
        function class_1(props) {
            var _this = _super.call(this, props) || this;
            _this.parentElement = null;
            _this.resizeCallback = function () {
                var fitToParentWidth = function () { return _.isObject(_this.props.fitToParent) && _.isBoolean(_this.props.fitToParent.toWidth) && _this.props.fitToParent.toWidth; };
                var fitToParentHeight = function () { return _.isObject(_this.props.fitToParent) && _.isBoolean(_this.props.fitToParent.toHeight) && _this.props.fitToParent.toHeight; };
                var fitToParentWidthOffset = function () { return _.isObject(_this.props.fitToParent) && _.isNumber(_this.props.fitToParent.offsetWidth) ? _this.props.fitToParent.offsetWidth : 0; };
                var fitToParentHeightOffset = function () { return _.isObject(_this.props.fitToParent) && _.isNumber(_this.props.fitToParent.offsetHeight) ? _this.props.fitToParent.offsetHeight : 0; };
                if (_.isObject(_this.parentElement)) {
                    if (fitToParentWidth()) {
                        _this.setState({ width: _this.parentElement.clientWidth - fitToParentWidthOffset() });
                    }
                    if (fitToParentHeight()) {
                        _this.setState({ height: _this.parentElement.clientHeight - fitToParentHeightOffset() });
                    }
                }
            };
            _this.state = {
                width: props.scss.widthPx,
                height: props.scss.heightPx,
            };
            return _this;
        }
        class_1.prototype.componentWillMount = function () {
            this.resizeCallback();
        };
        class_1.prototype.componentDidMount = function () {
            window.addEventListener("resize", this.resizeCallback);
            this.resizeCallback();
        };
        class_1.prototype.componentWillUnmount = function () {
            window.removeEventListener("resize", this.resizeCallback);
        };
        class_1.prototype.render = function () {
            var _this = this;
            return React.createElement(WrappedComponent, __assign({}, this.props, { scss: _.extend(this.props.scss, {
                    widthPx: this.state.width,
                    heightPx: this.state.height,
                }), refCallback: function (ref) {
                    if (!_.isObject(_this.parentElement) && _.isObject(ref)) {
                        _this.parentElement = ref.parentElement;
                        _this.resizeCallback();
                    }
                } }));
        };
        return class_1;
    }(React.Component));
}
exports.withFitToParent = withFitToParent;
//# sourceMappingURL=with-fit-to-parent.js.map