"use strict";
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
}
Object.defineProperty(exports, "__esModule", { value: true });
var enums_1 = require("./enums");
var _ = __importStar(require("lodash"));
var translateValueToHandleLeftPositionPx = function (domain, scss, type, value) {
    var result = (value - domain.domainMin) / (domain.domainMax - domain.domainMin) * scss.widthPx;
    if (type == enums_1.EnumHandleType.Right)
        result -= scss.handleWidthPx;
    return _.isNaN(result) ? 0 : result;
};
/**
 * Translates length provided in pixels to an equivalent expressed in domain units
 */
var expressLengthPxInDomain = function (domain, scss, lengthPx) {
    return (lengthPx / scss.widthPx) * (domain.domainMax - domain.domainMin);
};
var expressDomainLengthInPx = function (domain, scss, length) {
    return _.reduce([(length / (domain.domainMax - domain.domainMin) * scss.widthPx)], function (sum, el) { return _.isNaN(el) ? 0 : el; }, 0);
};
exports.calculations = {
    translateValueToHandleLeftPositionPx: translateValueToHandleLeftPositionPx,
    expressLengthPxInDomain: expressLengthPxInDomain,
    expressDomainLengthInPx: expressDomainLengthInPx
};
//# sourceMappingURL=calculations.js.map