/// <reference types="react" />
import * as React from 'react';
import { EnumHandleType } from '../enums';
import { IDomain } from '../interfaces';
import { IHpSliderScss } from '../../sass/styles';
export interface IHpSliderHandleMoved {
    (newValue: number | number[], handle: EnumHandleType): void;
}
export interface IHpSliderHandlePressed {
    (pressed: boolean, handle: EnumHandleType): void;
}
export interface IHpSliderHandleProps {
    scss: IHpSliderScss;
    handleType: EnumHandleType;
    domain: IDomain<number>;
    /**
     * For EnumHandleType.Left or EnumHandleType.Right it just a value (in domain),
     * for EnumHandleType.Bar it is a two dimensional array describing
     * value left, value right in domain.
     *
     * TODO: migrate number[] to IHpSliderHandleValues
     */
    value: number | number[];
    onMoved?: IHpSliderHandleMoved;
    onPressed?: IHpSliderHandlePressed;
}
export interface IHpSliderHandleState {
    isPressed?: boolean;
    previousScreenX?: number | null;
}
export declare class HpSliderHandle extends React.Component<IHpSliderHandleProps, IHpSliderHandleState> {
    constructor(props: any);
    componentDidMount(): void;
    componentWillUnmount(): void;
    getHandleStyle: () => React.CSSProperties;
    getClassName: () => string;
    globalMouseUp: (e: any) => boolean;
    globalMouseMove: (e: any) => boolean;
    render(): JSX.Element;
}
