import { Action } from 'redux';
import { IExternalSourceTimeSeries } from './state/time-series';
import { IUnixTimeRangeSelection } from './state/unix-time-range-selection';
declare class GenerateRandomDataAction implements Action {
    from: Date;
    to: Date;
    readonly type: string;
    constructor(from: Date, to: Date);
}
declare class SetDataAction implements Action {
    series: IExternalSourceTimeSeries[];
    readonly type: string;
    constructor(series: IExternalSourceTimeSeries[]);
}
declare class AddRangeSelectionAction implements Action {
    selection: IUnixTimeRangeSelection;
    readonly type: string;
    constructor(selection: IUnixTimeRangeSelection);
}
declare class RemoveRangeSelectionAction implements Action {
    unix: number;
    readonly type: string;
    constructor(unix: number);
}
export { GenerateRandomDataAction, SetDataAction, AddRangeSelectionAction, RemoveRangeSelectionAction };
