/// <reference types="react" />
import { IHpTimeSeriesChartScss } from '../sass/styles';
import { IHpTimeSeriesChartState } from './state';
import { IInteractions } from './interactions';
export declare enum EnumHpTimeSeriesChartMode {
    Standalone = 0,
    SliderEmbedded = 1,
}
export interface IHpTimeSeriesChartBaseProps {
    state: IHpTimeSeriesChartState;
    scss: IHpTimeSeriesChartScss;
    interactions?: IInteractions;
    mode?: EnumHpTimeSeriesChartMode;
    /**
     * Optional parameter giving the ability to set custom D3 y-axis scale domain.
     * The domain in this case is just a pair of numbers indicating
     * the maximum and minimum value.
     *
     * If not set, the minimum/maximum value is the minimum/maximum float
     * number found in all the series.
     */
    scaleLinearDomain?: (yMin: number, yMax: number) => {
        yMin: number;
        yMax: number;
    };
    /**
     * Set formatting accordingly: https://github.com/d3/d3-time-format/blob/master/README.md#timeFormat
     */
    dateTimeAxisTickFormat?: string;
    refCallback?: (ref: any) => void;
}
export declare const HpTimeSeriesChartBase: (props: IHpTimeSeriesChartBaseProps) => JSX.Element;
