"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
}
Object.defineProperty(exports, "__esModule", { value: true });
var lodash_1 = __importDefault(require("lodash"));
var react_1 = __importDefault(require("react"));
var svg_rect_1 = require("./svg-rect");
// Dot-Time-Series prefix in key name must stay here, since DottedLine type of series draws two types of chart one one another
var getTimeSeriesKey = function (ctx) { return "Dot-Time-Series|" + ctx.ts.name + "|" + ctx.ts.fragmentId; };
var getRectKey = function (ts, b) {
    return ts.name + "|" + ts.fragmentId + "|" + b.firstSample.unix + "|" + b.lastSample.unix;
};
exports.renderBarTimeSeries = function (ctx) {
    return react_1.default.createElement("g", { key: getTimeSeriesKey(ctx) }, lodash_1.default.map(ctx.ts.buckets.buckets, function (b) {
        return react_1.default.createElement(svg_rect_1.SvgRect, { ctx: ctx, date: new Date(b.unixFrom), y: b.maxY, key: getRectKey(ctx.ts, b) });
    }));
};
//# sourceMappingURL=bar-time-series.js.map