/// <reference types="react" />
import { ITimeSeriesRendererContext } from '.';
export declare enum EnumDotRenderStrategy {
    /**
     * Shows all buckets as they are - without any filtering.
     * Please note that doing so results in heavy performance penalty -
     * choosing the proper strategy should depend on number of buckets / samples
     */
    ShowAll = 0,
    /**
     * Shows samples as they are in buckets with the following restrictions:
     * a) only buckets that represent data source samples (see numberOfSamples == 1 criteria below) are shown
     * a) only buckets that are "far enough" (measured in the screen domain) are shown
     */
    ShowDataSourceProximityFiltered = 1,
}
export declare const renderDotTimeSeries: (ctx: ITimeSeriesRendererContext, strategy: EnumDotRenderStrategy) => JSX.Element;
