"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
}
Object.defineProperty(exports, "__esModule", { value: true });
var _ = __importStar(require("lodash"));
var React = __importStar(require("react"));
var enums_1 = require("../../state/enums");
var line_time_series_1 = require("./line-time-series");
var dot_time_series_1 = require("./dot-time-series");
var bar_time_series_1 = require("./bar-time-series");
var TimeSeries = /** @class */ (function (_super) {
    __extends(TimeSeries, _super);
    function TimeSeries(props) {
        return _super.call(this, props) || this;
    }
    TimeSeries.prototype.renderSvgPrimitives = function () {
        var _this = this;
        var result = [];
        _.each(this.props.chartTimeSeries, function (ts) {
            var ctx = {
                ts: ts,
                xScale: _this.props.xScale,
                yScale: _this.props.yScale,
                yMin: _this.props.yMin,
                yMax: _this.props.yMax,
            };
            switch (ts.type) {
                case enums_1.EnumTimeSeriesType.Line:
                    result.push(line_time_series_1.renderLineTimeSeries(ctx));
                    break;
                case enums_1.EnumTimeSeriesType.Dots:
                    result.push(dot_time_series_1.renderDotTimeSeries(ctx, dot_time_series_1.EnumDotRenderStrategy.ShowAll));
                    break;
                case enums_1.EnumTimeSeriesType.DottedLine:
                    result.push(line_time_series_1.renderLineTimeSeries(ctx));
                    result.push(dot_time_series_1.renderDotTimeSeries(ctx, dot_time_series_1.EnumDotRenderStrategy.ShowDataSourceProximityFiltered));
                    break;
                case enums_1.EnumTimeSeriesType.Bars:
                    result.push(bar_time_series_1.renderBarTimeSeries(ctx));
                    break;
            }
        });
        return result;
    };
    TimeSeries.prototype.render = function () {
        return (React.createElement("g", null, this.renderSvgPrimitives()));
    };
    return TimeSeries;
}(React.Component));
exports.TimeSeries = TimeSeries;
//# sourceMappingURL=index.js.map