"use strict";
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
}
Object.defineProperty(exports, "__esModule", { value: true });
var _ = __importStar(require("lodash"));
var dateFns = __importStar(require("date-fns"));
var debug = false;
var EnumRawCsvFormat;
(function (EnumRawCsvFormat) {
    EnumRawCsvFormat[EnumRawCsvFormat["DateTimeThenValue"] = 0] = "DateTimeThenValue";
    EnumRawCsvFormat[EnumRawCsvFormat["UnixTimeThenValue"] = 1] = "UnixTimeThenValue";
})(EnumRawCsvFormat = exports.EnumRawCsvFormat || (exports.EnumRawCsvFormat = {}));
var extractUnixTimePoints = function (csvRows, config) {
    return _.map(csvRows, function (row) {
        return {
            unix: (function () {
                switch (config.rawFormat) {
                    case EnumRawCsvFormat.UnixTimeThenValue:
                        return parseInt(row[config.timeStampColumnName]);
                    case EnumRawCsvFormat.DateTimeThenValue:
                        return dateFns.parse(row[config.timeStampColumnName]).getTime();
                }
            })(),
            value: parseFloat(row[config.valueColumnName])
        };
    });
};
exports.csvLoadingCalculations = {
    extractUnixTimePoints: extractUnixTimePoints
};
//# sourceMappingURL=calculations.js.map