/// <reference types="react" />
import * as React from 'react';
import { IDomain } from '../hp-slider/interfaces';
import { IHpTimeSeriesChartScssGeneric, IHpSliderScssGeneric } from '../sass/styles';
import { IHpTimeSeriesChartState } from '../hp-time-series-chart/state';
import { IInteractions } from '../hp-time-series-chart/interactions';
export interface IHpTimeSeriesScrollerProps {
    chartState: IHpTimeSeriesChartState;
    sliderScss: IHpSliderScssGeneric<number>;
    timeSeriesChartScss: IHpTimeSeriesChartScssGeneric<number>;
    interactions?: IInteractions;
    displaySlider?: boolean;
    fitToParentSize?: boolean;
}
export interface IHpTimeSeriesScrollerState {
    windowUnixFrom: number;
    windowUnixTo: number;
    chartState: IHpTimeSeriesChartState;
    sliderScss: IHpSliderScssGeneric<number>;
    timeSeriesChartScss: IHpTimeSeriesChartScssGeneric<number>;
}
/**
 * This statefull component aggregates HpTimeSeriesChart and HpSlider components, acting as an example how to use them.
 * It can be used as a production-ready solution as well.
 * For non-Redux usage please HpTimeSeriesScrollerWrapper.
 */
export declare class HpTimeSeriesScroller extends React.Component<IHpTimeSeriesScrollerProps, IHpTimeSeriesScrollerState> {
    private parentElement;
    constructor(props: IHpTimeSeriesScrollerProps);
    componentWillReceiveProps(nextProps: Readonly<IHpTimeSeriesScrollerProps>, nextContext: any): void;
    getDomain: () => IDomain<number>;
    private _getChartInSliderDimensions;
    private resizeCallback;
    componentWillMount(): void;
    componentDidMount(): void;
    componentWillUnmount(): void;
    render(): JSX.Element;
}
