"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
}
Object.defineProperty(exports, "__esModule", { value: true });
var _ = __importStar(require("lodash"));
var React = __importStar(require("react"));
var hp_slider_1 = require("../hp-slider");
var hp_time_series_chart_1 = require("../hp-time-series-chart");
var slider_to_chart_integration_1 = require("../common/slider-to-chart-integration");
/**
 * This statefull component aggregates HpTimeSeriesChart and HpSlider components, acting as an example how to use them.
 * It can be used as a production-ready solution as well.
 * For non-Redux usage please HpTimeSeriesScrollerWrapper.
 */
var HpTimeSeriesScroller = /** @class */ (function (_super) {
    __extends(HpTimeSeriesScroller, _super);
    function HpTimeSeriesScroller(props) {
        var _this = _super.call(this, props) || this;
        _this.getDomain = function () {
            return { domainMin: _this.props.chartState.dateRangeUnixFrom, domainMax: _this.props.chartState.dateRangeUnixTo };
        };
        _this._getChartInSliderDimensions = function () {
            return {
                heightPx: _this.props.sliderScss.heightPx,
                widthPx: _this.props.timeSeriesChartScss.widthPx,
                paddingBottomPx: 0,
                paddingLeftPx: 0,
                paddingRightPx: 0,
                paddingTopPx: 0
            };
        };
        _this.resizeCallback = function () {
            if (_.isObject(_this.parentElement) && _.isBoolean(_this.props.fitToParentSize) && _this.props.fitToParentSize) {
                _this.setState({
                    sliderScss: _.extend(_this.state.sliderScss, {
                        widthPx: _this.parentElement.clientWidth
                    }),
                    timeSeriesChartScss: _.extend(_this.state.timeSeriesChartScss, {
                        widthPx: _this.parentElement.clientWidth,
                        heightPx: _this.parentElement.clientHeight
                    })
                });
            }
        };
        _this.state = {
            windowUnixFrom: props.chartState.dateRangeUnixFrom,
            windowUnixTo: props.chartState.dateRangeUnixTo,
            chartState: _.cloneDeep(props.chartState),
            sliderScss: props.sliderScss,
            timeSeriesChartScss: props.timeSeriesChartScss
        };
        return _this;
    }
    HpTimeSeriesScroller.prototype.componentWillReceiveProps = function (nextProps, nextContext) {
        this.setState(_.extend({}, {
            chartState: _.cloneDeep(nextProps.chartState),
            sliderScss: _.extend(nextProps.sliderScss, _.isObject(this.parentElement) && _.isBoolean(this.props.fitToParentSize) && this.props.fitToParentSize ? {
                widthPx: this.parentElement.clientWidth
            } : {}),
            timeSeriesChartScss: _.extend(nextProps.timeSeriesChartScss, _.isObject(this.parentElement) && _.isBoolean(this.props.fitToParentSize) && this.props.fitToParentSize ? {
                widthPx: this.parentElement.clientWidth,
                heightPx: this.parentElement.clientHeight
            } : {}),
            windowUnixFrom: nextProps.chartState.windowUnixFrom,
            windowUnixTo: nextProps.chartState.windowUnixTo
        }));
    };
    HpTimeSeriesScroller.prototype.componentWillMount = function () {
        this.resizeCallback();
    };
    HpTimeSeriesScroller.prototype.componentDidMount = function () {
        window.addEventListener("resize", this.resizeCallback);
        this.resizeCallback();
    };
    HpTimeSeriesScroller.prototype.componentWillUnmount = function () {
        window.removeEventListener("resize", this.resizeCallback);
        if (_.isObject(this.parentElement)) {
            this.parentElement.onmouseup = null;
            this.parentElement.onmousedown = null;
        }
    };
    HpTimeSeriesScroller.prototype.render = function () {
        var _this = this;
        return (React.createElement("div", { ref: function (el) {
                if (_.isObject(el))
                    _this.parentElement = el.parentElement;
            } },
            React.createElement(hp_time_series_chart_1.HpTimeSeriesChart, { scss: this.state.timeSeriesChartScss, state: this.state.chartState }),
            React.createElement("br", null),
            (_.isBoolean(this.props.displaySlider) ? this.props.displaySlider : true) &&
                React.createElement(hp_slider_1.HpSlider, { domain: this.getDomain(), handleValues: { left: this.state.windowUnixFrom, right: this.state.windowUnixTo }, scss: this.props.sliderScss, displayDragBar: true, handleMoved: function (value, type) {
                        var _a = slider_to_chart_integration_1.handleMovedCallback(value, type, _this.state), windowUnixFrom = _a.windowUnixFrom, windowUnixTo = _a.windowUnixTo;
                        _this.setState({
                            windowUnixFrom: windowUnixFrom,
                            windowUnixTo: windowUnixTo,
                            chartState: _.extend(_this.state.chartState, {
                                windowUnixFrom: windowUnixFrom,
                                windowUnixTo: windowUnixTo
                            })
                        });
                    } },
                    React.createElement(hp_time_series_chart_1.HpTimeSeriesChart, { scss: this._getChartInSliderDimensions(), state: this.props.chartState, mode: hp_time_series_chart_1.EnumHpTimeSeriesChartMode.SliderEmbedded }))));
    };
    return HpTimeSeriesScroller;
}(React.Component));
exports.HpTimeSeriesScroller = HpTimeSeriesScroller;
//# sourceMappingURL=index.js.map